#include "InputManager.h"

namespace JEngine
{
	InputManager::InputManager() : _mouseCoords(0.0f)
	{
	}


	InputManager::~InputManager()
	{
	}

	void InputManager::pressKey(unsigned int keyID)
	{
		_keyMap[keyID] = true;
	}

	void InputManager::releaseKey(unsigned int keyID)
	{
		_keyMap[keyID] = false;
	}

	
	void InputManager::setMouseCoords(float x, float y)
	{
		_mouseCoords.x = x;
		_mouseCoords.y = y;
	}


	bool InputManager::isKeyDown(unsigned int keyID)
	{
		// don't use return _keyMap[keyID], because it may not exist (yet)!
		// so it'll create it and give it some value
		auto it = _keyMap.find(keyID);

		if (it != _keyMap.end())
		{
			return it->second;
		}
		else
		{
			return false;
		}
	}
}