#pragma once

#include <glm/glm.hpp>
#include <vector>
#include <JEngine/SpriteBatch.h>

class Human;
class Zombie;
class Agent;

class Bullet
{
public:
	Bullet(glm::vec2 pos, glm::vec2 dir, float vel, float dmg);
	~Bullet();

	// on return true, delete bullet
	bool update(const std::vector<std::string>& levelData);

	void draw(JEngine::SpriteBatch& sb);

	bool collideWithAgent(Agent* agent);

	// getters
	float getDamage() const { return _dmg; }

private:
	bool collideWithWorld(const std::vector<std::string>& levelData);

	float _dmg;
	float _vel;
	glm::vec2 _pos;
	glm::vec2 _dir;
};

