#include "Gun.h"
#include "Potion.h"

#include <random>
#include <time.h>
#include <glm/gtx/rotate_vector.hpp>


Gun::Gun(std::string name, int fireRate, int bulletsPerShot, float spread, float bulletDamage, float bulletSpeed) :
_name(name),
_fireRate(fireRate),
_bulletsPerShot(bulletsPerShot),
_spread(spread),
_bulletDamage(bulletDamage),
_bulletSpeed(bulletSpeed),
_frameCounter(0),
_rateTicks(0),
_damageTicks(0)
{
}

Gun::~Gun()
{
}

// well shit.
// forgot I had multiple guns.
void Gun::amplifyDamage()
{
	if (_damageTicks == 0)
		_bulletDamage *= 4;
	_damageTicks = POTION_TIME;
}

void Gun::amplifyRate()
{
	if (_rateTicks == 0)
		_fireRate /= 2;
	_rateTicks = POTION_TIME;
}

void Gun::update(bool isMouseDown, const glm::vec2& position, glm::vec2 direction, std::vector<Bullet>& bullets)
{
	_frameCounter++;
	if (_frameCounter >= _fireRate && isMouseDown)
	{
		fire(position, direction, bullets);
		_frameCounter = 0;
	}

	if (_damageTicks > 0 && --_damageTicks == 0)
	{
		_bulletDamage /= 4;
	}

	if (_rateTicks > 0 && --_rateTicks == 0)
	{
		_fireRate *= 2;
	}
}

void Gun::fire(const glm::vec2& position, const glm::vec2& direction, std::vector<Bullet>& bullets)
{
	std::mt19937 randomEngine(time(nullptr));
	std::uniform_real_distribution<float> randomRotate(-_spread, _spread);

	for (int i = 0; i < _bulletsPerShot; i++)
	{
		bullets.emplace_back(position,
							 glm::rotate(direction, randomRotate(randomEngine)),
							 _bulletSpeed,
							 _bulletDamage);
	}
}
