#include "Human.h"

#include <random>
#include <ctime>
#include <glm/gtx/rotate_vector.hpp>


Human::Human() :
	_frames(0)
{
	_health = 35.0f;
}


Human::~Human()
{
}

void Human::init(float speed, glm::vec2 pos)
{	
	static std::mt19937 randomEngine(time(nullptr));
	static std::uniform_real_distribution<float> randDir(-1.0f, 1.0f);

	_color.setColor(200, 0, 200);

	_speed = speed;
	_pos = pos;
	_direction = glm::vec2(randDir(randomEngine), randDir(randomEngine));

	_direction = glm::normalize(_direction);
}

void Human::update(const std::vector<std::string>& levelData,
	std::vector<Human*>& humans,
	std::vector<Zombie*>& zombies)
{
	static std::mt19937 randomEngine(time(nullptr));
	static std::uniform_real_distribution<float> randomRotate(-40.0f, 40.0f);

	_pos += _direction * _speed;

	if (_frames == 20)
	{
		_direction = glm::rotate(_direction, randomRotate(randomEngine));
		_frames = 0;
	}
	else
	{
		_frames++;
	}

	if (collideWithLevel(levelData))
	{
		_direction = glm::rotate(_direction, randomRotate(randomEngine));
		_frames = 0;
	}
}
