#pragma once

#include "Human.h"
#include "Bullet.h"

#include <JEngine/InputManager.h>
#include <JEngine/Camera2D.h>

enum class PotionEffect;
class Gun;

class Player : public Human
{
public:
	Player();
	~Player();

	void init(float speed, glm::vec2 pos, JEngine::InputManager* inputManager, JEngine::Camera2D* camera, std::vector<Bullet>* bullets);

	void addGun(Gun* gun);

	void addPotion(PotionEffect effect);

	virtual void update(const std::vector<std::string>& levelData,
		std::vector<Human*>& humans,
		std::vector<Zombie*>& zombies);

private:
	JEngine::InputManager* _inputManager;
	JEngine::Camera2D* _camera;

	std::vector<Bullet>* _bullets;
	std::vector<Gun*> _guns;
	int _currentGun;

	int _speedUpTicks;
};

