#pragma once

#include <glm/glm.hpp>
#include <JEngine/SpriteBatch.h>

enum class PotionEffect
{
	SPEED_UP,
	EXTRA_DAMAGE,
	FASTER_SHOOTING,
	END
};

const unsigned short POTION_SIZE = 32;
const unsigned short POTION_RADIUS = 16;

const unsigned int POTION_TIME = 1500;

class Player;

class Potion
{
public:
	Potion(const std::vector<std::string>& levelData, int addseed = 0);
	~Potion();

	void draw(JEngine::SpriteBatch& sb);

	bool collideWithPlayer(Player* player);

	bool update();

	// getters
	PotionEffect getPotionEffect() const { return _effect; }
private:
	JEngine::Color _color;
	glm::vec2 _pos;
	PotionEffect _effect;

	unsigned int _ticksToLive;
};

